# Visa Commercial Fraud Solutions
Visa Commercial Fraud Solutions addresses various client needs across the commercial payments ecosystem. These solutions connect authentication, authorization intelligence, supplier integrity, and spend governance into a cohesive experience supporting large enterprise, middle-market companies, and small businesses. By aligning network-level intelligence, AI driven insights, configurable controls, and operational tools across the payment lifecycle, Visa helps issuers address evolving digital fraud risks while supporting secure, efficient commercial payment experiences.

## Version: 1

### Servers

| URL | Description |
| --- | ----------- |
| https://sandbox.api.visa.com | Sandbox server |

---
## Contact Management - Deprecated
Users can use Contact Management APIs to add email and mobile contacts to the existing accounts in VPC to receive notifications. Users can also manage contacts and are able to delete the contacts associated to an account or fetch all the contacts associated with the card.<br><br><b>Response code and description</b>: Refer to <a href=/capabilities/visa-b2b-payment-controls/docs-error-codes>Response code and description.</a>

### [POST] /vpc/v1/contactManagement/get
**Get Contact Details**

Users can use Get Contact API to fetch all the contact details associated to the account which will receive the notifications.

#### Request Body

Users can use Get Contact API to fetch all the contact details associated to the account which will receive the notifications.

| Required | Schema |
| -------- | ------ |
|  No | **application/json-patch+json**: { **"accounts"**: [ { **"serviceKey"**: string, **"accountNumber"**: string, **"sequenceNumber"**: string } ], **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string }<br>**application/json**: { **"accounts"**: [ { **"serviceKey"**: string, **"accountNumber"**: string, **"sequenceNumber"**: string } ], **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string }<br>**text/json**: { **"accounts"**: [ { **"serviceKey"**: string, **"accountNumber"**: string, **"sequenceNumber"**: string } ], **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string }<br>**application/*+json**: { **"accounts"**: [ { **"serviceKey"**: string, **"accountNumber"**: string, **"sequenceNumber"**: string } ], **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Success Response | **application/json**: { **"data"**: [ { **"accountsContacts"**: [ { **"status"**: string, **"contacts"**: [ { **"isHTML"**: boolean, **"contactType"**: string, **"countryCode"**: string, **"contactValue"**: string, **"languageCode"**: string } ], **"serviceKey"**: string, **"accountLast4"**: string, **"statusMessage"**: string, **"sequenceNumber"**: string, **"statusMessageCode"**: string } ] } ], **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 207 | Mutli-status responses. This response is seen in case of bulk request scenario. For this response, go through each response to get the status of each contact. | **application/json**: { **"data"**: [ { **"accountsContacts"**: [ { **"status"**: string, **"contacts"**: [ { **"isHTML"**: boolean, **"contactType"**: string, **"countryCode"**: string, **"contactValue"**: string, **"languageCode"**: string } ], **"serviceKey"**: string, **"accountLast4"**: string, **"statusMessage"**: string, **"sequenceNumber"**: string, **"statusMessageCode"**: string } ] } ], **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 400 | Error Response | **application/json**: { **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |

### [POST] /vpc/v1/contactManagement/create
**Create Contact**

The Create Contact API allows user to add a mobile or email contacts to an existing account within VPC to receive the transaction notifications in their configured language.<br><br><b>Note</b>: Email notifications support Issuer/Entity branding and notification text is customizable. This will be part of the implementation process to set up the templates.

#### Request Body

The Create Contact API allows user to add a mobile or email contacts to an existing account within VPC to receive the transaction notifications in their configured language.<br><br><b>Note</b>: Email notifications support Issuer/Entity branding and notification text is customizable. This will be part of the implementation process to set up the templates.

| Required | Schema |
| -------- | ------ |
|  No | **application/json-patch+json**: { **"clientId"**: string, **"contacts"**: [ { **"isHTML"**: boolean, **"contactType"**: string, **"countryCode"**: string, **"contactValue"**: string, **"languageCode"**: string, **"sequenceNumber"**: string } ], **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string, **"serviceKey"**: string, **"accountNumber"**: string }<br>**application/json**: { **"clientId"**: string, **"contacts"**: [ { **"isHTML"**: boolean, **"contactType"**: string, **"countryCode"**: string, **"contactValue"**: string, **"languageCode"**: string, **"sequenceNumber"**: string } ], **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string, **"serviceKey"**: string, **"accountNumber"**: string }<br>**text/jso**: { **"clientId"**: string, **"contacts"**: [ { **"isHTML"**: boolean, **"contactType"**: string, **"countryCode"**: string, **"contactValue"**: string, **"languageCode"**: string, **"sequenceNumber"**: string } ], **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string, **"serviceKey"**: string, **"accountNumber"**: string }<br>**application/*+json**: { **"clientId"**: string, **"contacts"**: [ { **"isHTML"**: boolean, **"contactType"**: string, **"countryCode"**: string, **"contactValue"**: string, **"languageCode"**: string, **"sequenceNumber"**: string } ], **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string, **"serviceKey"**: string, **"accountNumber"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Success Response | **application/json**: { **"data"**: { **"serviceKey"**: string, **"accountLast4"**: string, **"contactsStatus"**: [ { **"status"**: string, **"statusMessage"**: string, **"sequenceNumber"**: string, **"statusMessageCode"**: string } ] }, **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 207 | Mutli-status responses. This response is seen in case of bulk request scenario. For this response, go through each response to get the status of each contact. | **application/json**: { **"data"**: { **"serviceKey"**: string, **"accountLast4"**: string, **"contactsStatus"**: [ { **"status"**: string, **"statusMessage"**: string, **"sequenceNumber"**: string, **"statusMessageCode"**: string } ] }, **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 400 | Error Response | **application/json**: { **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |

### [DELETE] /vpc/v1/contactManagement/delete
**Delete Contact**

Users can use Delete Contact API to remove the contact from an account. This will prevent them from receiving future notifications.

#### Request Body

Users can use Delete Contact API to remove the contact from an account. This will prevent them from receiving future notifications.

| Required | Schema |
| -------- | ------ |
|  No | **application/json-patch+json**: { **"clientId"**: string, **"contacts"**: [ { **"contactType"**: string, **"contactValue"**: string, **"sequenceNumber"**: string } ], **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string, **"serviceKey"**: string, **"accountNumber"**: string }<br>**application/json**: { **"clientId"**: string, **"contacts"**: [ { **"contactType"**: string, **"contactValue"**: string, **"sequenceNumber"**: string } ], **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string, **"serviceKey"**: string, **"accountNumber"**: string }<br>**text/json**: { **"clientId"**: string, **"contacts"**: [ { **"contactType"**: string, **"contactValue"**: string, **"sequenceNumber"**: string } ], **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string, **"serviceKey"**: string, **"accountNumber"**: string }<br>**application/*+json**: { **"clientId"**: string, **"contacts"**: [ { **"contactType"**: string, **"contactValue"**: string, **"sequenceNumber"**: string } ], **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string, **"serviceKey"**: string, **"accountNumber"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Success Response | **application/json**: { **"data"**: { **"serviceKey"**: string, **"accountLast4"**: string, **"contactsStatus"**: [ { **"status"**: string, **"statusMessage"**: string, **"sequenceNumber"**: string, **"statusMessageCode"**: string } ] }, **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 207 | Mutli-status responses. This response is seen in case of bulk request scenario. For this response, go through each response to get the status of each contact. | **application/json**: { **"data"**: { **"serviceKey"**: string, **"accountLast4"**: string, **"contactsStatus"**: [ { **"status"**: string, **"statusMessage"**: string, **"sequenceNumber"**: string, **"statusMessageCode"**: string } ] }, **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 400 | Error Response | **application/json**: { **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |

---
## Company Management - Deprecated
The Company Management API promotes self-service for company onboarding and ongoing company management.  It allows an entity to create a company, update company settings, delete a company, and well as retrieve all company setup details along with the cards associated to that company profile.<br><br><b>Response code and description</b>: Refer to <a href=/capabilities/visa-b2b-payment-controls/docs-error-codes>Response code and description.</a>

### [POST] /vpc/v1/companyManagement/get
**Get Company Details**

The Get Company Details API allows you to retrieve all the details of a company setup in VPC.  This will provide back the company information including company contact information, portfolio and setup information, as well as the service key and corresponding account information for those accounts linked to the company.

#### Request Body

The Get Company Details API allows you to retrieve all the details of a company setup in VPC.  This will provide back the company information including company contact information, portfolio and setup information, as well as the service key and corresponding account information for those accounts linked to the company.

| Required | Schema |
| -------- | ------ |
|  No | **application/json-patch+json**: { **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string }<br>**application/json**: { **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string }<br>**text/json**: { **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string }<br>**application/*+json**: { **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Success Response | **application/json**: { **"data"**: { **"Accounts"**: [ { **"expDate"**: string, **"isToken"**: boolean, **"serviceKey"**: string, **"accountLast4"**: string, **"cardholderLastName"**: string, **"cardholderFirstName"**: string } ], **"companyId"**: string, **"issuerBid"**: string, **"companyName"**: string, **"portfolioId"**: string, **"contactEmail"**: string, **"contactPhone"**: string, **"totalAccounts"**: string }, **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 400 | Error Response | **application/json**: { **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |

### [PUT] /vpc/v1/companyManagement/update
**Update Company**

The Update Company API allows users to modify the existing company setup in VPC.  You can update the company name as well as company contact email or phone number.

#### Request Body

The Update Company API allows users to modify the existing company setup in VPC.  You can update the company name as well as company contact email or phone number.

| Required | Schema |
| -------- | ------ |
|  No | **application/json-patch+json**: { **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string, **"newCompanyName"**: string, **"newContactEmail"**: string, **"newContactPhone"**: string }<br>**application/json**: { **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string, **"newCompanyName"**: string, **"newContactEmail"**: string, **"newContactPhone"**: string }<br>**text/json**: { **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string, **"newCompanyName"**: string, **"newContactEmail"**: string, **"newContactPhone"**: string }<br>**application/*+json**: { **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string, **"newCompanyName"**: string, **"newContactEmail"**: string, **"newContactPhone"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Success Response | **application/json**: { **"data"**: { **"companyId"**: string }, **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 400 | Error Response | **application/json**: { **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |

### [POST] /vpc/v1/companyManagement/create
**Create Company**

The Create Company APIs allows users to setup a company in VPC.  After company setup, you can add accounts, add contacts for notifications, and set controls.<br><br><b>Note</b>:  Users have the ability to create individual companies or a larger global company.

#### Request Body

The Create Company APIs allows users to setup a company in VPC.  After company setup, you can add accounts, add contacts for notifications, and set controls.<br><br><b>Note</b>:  Users have the ability to create individual companies or a larger global company.

| Required | Schema |
| -------- | ------ |
|  No | **application/json-patch+json**: { **"clientId"**: string, **"issuerBid"**: string, **"requestID"**: string, **"companyName"**: string, **"accountRange"**: string, **"contactEmail"**: string, **"contactPhone"**: string }<br>**application/json**: { **"clientId"**: string, **"issuerBid"**: string, **"requestID"**: string, **"companyName"**: string, **"accountRange"**: string, **"contactEmail"**: string, **"contactPhone"**: string }<br>**text/json**: { **"clientId"**: string, **"issuerBid"**: string, **"requestID"**: string, **"companyName"**: string, **"accountRange"**: string, **"contactEmail"**: string, **"contactPhone"**: string }<br>**application/*+json**: { **"clientId"**: string, **"issuerBid"**: string, **"requestID"**: string, **"companyName"**: string, **"accountRange"**: string, **"contactEmail"**: string, **"contactPhone"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Success Response | **application/json**: { **"data"**: { **"companyId"**: string, **"portfolioId"**: string }, **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 400 | Error Response | **application/json**: { **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |

### [DELETE] /vpc/v1/companyManagement/delete
**Delete Company**

Use the Delete Company API call to remove an existing company from VPC.  Companies can only be removed if they do not have card accounts associated to them  to minimize service disruption.

#### Request Body

Use the Delete Company API call to remove an existing company from VPC.  Companies can only be removed if they do not have card accounts associated to them  to minimize service disruption.

| Required | Schema |
| -------- | ------ |
|  No | **application/json-patch+json**: { **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string }<br>**application/json**: { **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string }<br>**text/json**: { **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string }<br>**application/*+json**: { **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Success Response | **application/json**: { **"data"**: { **"companyId"**: string }, **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 400 | Error Response | **application/json**: { **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |

---
## Control Management - Deprecated
Users can use Controls Management APIs to manage controls on an existing account in VPC. User should always send all the rules to be set on an account. <br>Once the rules are set, they are active immediately. Rules cannot be set for future date. <br>Date based rules follow GMT timezone and must be set accordingly.<br><br><b>Response code and description</b>: Refer to <a href=/capabilities/visa-b2b-payment-controls/docs-error-codes>Response code and description</a>

### [POST] /vpc/v1/controlsManagement/replace
**Set AccountControls**

Set Account Controls API can be used to set controls on existing accounts in VPC. Controls can be set on an individual account or the same controls can be set on multiple accounts. There is a rule details table in Visa Developer Platform that includes all the rules and their required parameters.

#### Request Body

Set Account Controls API can be used to set controls on existing accounts in VPC. Controls can be set on an individual account or the same controls can be set on multiple accounts. There is a rule details table in Visa Developer Platform that includes all the rules and their required parameters.

| Required | Schema |
| -------- | ------ |
|  No | **application/json-patch+json**: { **"rules"**: [ { **"rule"**: object } ], **"accounts"**: [ { **"serviceKey"**: string, **"accountNumber"**: string, **"sequenceNumber"**: string } ], **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string, **"ruleCurrency"**: string }<br>**application/json**: { **"rules"**: [ { **"rule"**: object } ], **"accounts"**: [ { **"serviceKey"**: string, **"accountNumber"**: string, **"sequenceNumber"**: string } ], **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string, **"ruleCurrency"**: string }<br>**text/json**: { **"rules"**: [ { **"rule"**: object } ], **"accounts"**: [ { **"serviceKey"**: string, **"accountNumber"**: string, **"sequenceNumber"**: string } ], **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string, **"ruleCurrency"**: string }<br>**application/*+json**: { **"rules"**: [ { **"rule"**: object } ], **"accounts"**: [ { **"serviceKey"**: string, **"accountNumber"**: string, **"sequenceNumber"**: string } ], **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string, **"ruleCurrency"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Success Response | **application/json**: { **"message"**: string, **"requestId"**: string, **"messageCode"**: string, **"accountsStatus"**: [ { **"status"**: string, **"ruleCount"**: string, **"serviceKey"**: string, **"accountLast4"**: string, **"statusMessage"**: string, **"sequenceNumber"**: string, **"statusMessageCode"**: string } ] }<br> |
| 207 | Mutli-status responses. This response is seen in case of bulk request scenario. For this response, go through each response to get the status of each account. | **application/json**: { **"message"**: string, **"requestId"**: string, **"messageCode"**: string, **"accountsStatus"**: [ { **"status"**: string, **"ruleCount"**: string, **"serviceKey"**: string, **"accountLast4"**: string, **"statusMessage"**: string, **"sequenceNumber"**: string, **"statusMessageCode"**: string } ] }<br> |
| 400 | Error Response | **application/json**: { **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |

### [POST] /vpc/v2/controlsManagement/get
**Get AccountControls**

Users can use Get Controls API to fetch all the controls set on an account. This API also provides the consumed amount limit and authorization count for the spend velocity control.

#### Request Body

Users can use Get Controls API to fetch all the controls along with mcgRuleAction set on an account. This API also provides the consumed amount limit and authorization count for the spend velocity control.

| Required | Schema |
| -------- | ------ |
|  No | **application/json-patch+json**: { **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string, **"serviceKey"**: string, **"accountNumber"**: string }<br>**application/json**: { **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string, **"serviceKey"**: string, **"accountNumber"**: string }<br>**text/json**: { **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string, **"serviceKey"**: string, **"accountNumber"**: string }<br>**application/*+json**: { **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string, **"serviceKey"**: string, **"accountNumber"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Success Response | **application/json**: { **"data"**: { **"rules"**: [ { **"rule"**: object } ], **"serviceKey"**: string, **"accountLast4"**: string, **"ruleCurrency"**: string, **"mcgRuleAction"**: string }, **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 400 | Error Response | **application/json**: { **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |

### [POST] /vpc/v1/controlsManagement/get
**Get AccountControls**

Users can use Get Controls API to fetch all the controls set on an account. This API also provides the consumed amount limit and authorization count for the spend velocity control.

#### Request Body

Users can use Get Controls API to fetch all the controls set on an account. This API also provides the consumed amount limit and authorization count for the spend velocity control.

| Required | Schema |
| -------- | ------ |
|  No | **application/json-patch+json**: { **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string, **"serviceKey"**: string, **"accountNumber"**: string }<br>**application/json**: { **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string, **"serviceKey"**: string, **"accountNumber"**: string }<br>**text/json**: { **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string, **"serviceKey"**: string, **"accountNumber"**: string }<br>**application/*+json**: { **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string, **"serviceKey"**: string, **"accountNumber"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Success Response | **application/json**: { **"data"**: { **"rules"**: [ { **"rule"**: object } ], **"serviceKey"**: string, **"accountLast4"**: string, **"ruleCurrency"**: string }, **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 400 | Error Response | **application/json**: { **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |

### [DELETE] /vpc/v1/controlsManagement/delete
**Delete AccountControls**

Users can use Delete Controls API to remove all the controls from the account. The rules will be removed immediately from one account or multiple accounts and these accounts can be used without any restriction.

#### Request Body

Users can use Delete Controls API to remove all the controls from the account. The rules will be removed immedialtely from one account or multiple accounts and these accounts can be used without any restriction.

| Required | Schema |
| -------- | ------ |
|  No | **application/json-patch+json**: { **"accounts"**: [ { **"serviceKey"**: string, **"accountNumber"**: string, **"sequenceNumber"**: string } ], **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string }<br>**application/json**: { **"accounts"**: [ { **"serviceKey"**: string, **"accountNumber"**: string, **"sequenceNumber"**: string } ], **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string }<br>**text/json**: { **"accounts"**: [ { **"serviceKey"**: string, **"accountNumber"**: string, **"sequenceNumber"**: string } ], **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string }<br>**application/*+json**: { **"accounts"**: [ { **"serviceKey"**: string, **"accountNumber"**: string, **"sequenceNumber"**: string } ], **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Success Response | **application/json**: { **"data"**: { **"accountsStatus"**: [ { **"status"**: string, **"serviceKey"**: string, **"accountLast4"**: string, **"statusMessage"**: string, **"sequenceNumber"**: string, **"statusMessageCode"**: string } ] }, **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 207 | Mutli-status responses. This response is seen in case of bulk request scenario. For this response, go through each response to get the status of each account. | **application/json**: { **"data"**: { **"accountsStatus"**: [ { **"status"**: string, **"serviceKey"**: string, **"accountLast4"**: string, **"statusMessage"**: string, **"sequenceNumber"**: string, **"statusMessageCode"**: string } ] }, **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 400 | Error Response | **application/json**: { **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |

---
## Commercial 3DS Authentication
The Commercial 3DS Authentication API provides a comprehensive suite of endpoints to manage the 3-D Secure (3DS) step-up authentication workflow for commercial virtual cards

### [POST] /vca/v1/commercial-validate/result
**Submit Validation Result**

This endpoint is designed for a Fintech to submit the outcome of a user's biometric authentication challenge.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"status"**: string, <br>**Available values:** "SUCCESS", "FAILURE", **"clientId"**: string, **"issuerId"**: string, **"issuerBid"**: string, **"acsClientId"**: string, **"authTraceId"**: string, **"processorId"**: string, **"errorMessage"**: string, **"transactionId"**: string, **"userMappingId"**: string, **"stepupRequestId"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 202 | Accepted. The validation result has been successfully received and is being processed. | **application/json**: { **"error"**: { **"code"**: string, **"message"**: string, **"errorDetails"**: [ { **"errorCode"**: string, **"errorMessage"**: string } ] }, **"status"**: string, <br>**Available values:** "ACCEPTED", "ERROR", **"requestId"**: string }<br> |
| 400 | Bad Request. The request body is missing required fields or contains invalid data. | **application/json**: { **"error"**: { **"code"**: string, **"message"**: string, **"errorDetails"**: [ { **"errorCode"**: string, **"errorMessage"**: string } ] }, **"status"**: string, <br>**Available values:** "ACCEPTED", "ERROR", **"requestId"**: string }<br> |
| 500 | Internal Server Error. An unexpected error occurred while processing the request. | **application/json**: { **"error"**: { **"code"**: string, **"message"**: string, **"errorDetails"**: [ { **"errorCode"**: string, **"errorMessage"**: string } ] }, **"status"**: string, <br>**Available values:** "ACCEPTED", "ERROR", **"requestId"**: string }<br> |

### [POST] /vca/v1/commercial-auth-data/authentication-record
**Save Authentication Record**

After the step-up process is fully completed and a definitive outcome is known, the ACS provider calls this endpoint to create a record of the authentication result.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"ECI"**: string, **"CAVV"**: string, **"CAVVHex"**: string, **"RequestID"**: string, **"RiskScore"**: string, **"ThreeRIInd"**: string, **"IssuerOrgId"**: string, **"MerchantInfo"**: { **"AcquirerId"**: string, **"MerchantId"**: string, **"MerchantURL"**: string, **"MerchantName"**: string, **"AcquirerCountryCode"**: string, **"MerchantCountryCode"**: string, **"MerchantCategoryCode"**: string, **"MerchantAppRedirectURL"**: string }, **"ExemptionInfo"**: { **"MCRiskScore"**: string, **"WhitelistStatus"**: string, **"MerchantFraudRate"**: string, **"WhitelistStatusSource"**: string, **"SecureCorporatePayment"**: string }, **"ExtensionData"**: { **"ACSRBA"**: { **"Score"**: string, **"Status"**: string, **"Decision"**: string, **"ReasonCode1"**: string, **"ReasonCode2"**: string }, **"DAFExtension"**: { **"Version"**: string, **"DAFAdvice"**: string, **"AuthPayCredStatus"**: string, <br>**Available values:** "Y", "N", "U", "B", "I", **"AuthPayProcessReqInd"**: string }, **"EMVPaymentToken"**: { **"Version"**: string, **"TokenRequestorId"**: string, **"TokenAdditionalData"**: { **"TokenCharacteristics"**: string, <br>**Available values:** "01", "02", "03", "05", "06", **"TokenAdditionalDataVersion"**: string }, **"TokenStatusIndicator"**: string }, **"VisaPaymentTokenExtension"**: { **"Token"**: string, **"Version"**: string, **"TokenCryptogram"**: string, **"TokenRequestorId"**: string, **"TokenAdditionalData"**: { **"TokenCharacteristics"**: string, <br>**Available values:** "01", "02", "03", "05", "06", **"TokenAdditionalDataVersion"**: string }, **"TokenAssuranceMethod"**: string, **"TokenStatusIndicator"**: string, <br>**Available values:** "A", "I", "S", "D", "P", **"TokenCryptogramValidityIndicator"**: string, <br>**Available values:** "01", "02", "03" } }, **"MessageVersion"**: string, **"DSTransactionId"**: string, **"TransactionInfo"**: { **"Channel"**: string, <br>**Available values:** "WEB", "APP", "MWEB", "THREERI", **"DeviceInfo"**: { **"IP"**: string, **"Locale"**: string, **"Latitude"**: string, **"Platform"**: string, **"SDKAppId"**: string, **"Longitude"**: string, **"UserAgent"**: string, **"DeviceName"**: string, **"DeviceModel"**: string, **"BrowserWidth"**: string, **"AdvertisingId"**: string, **"BrowserLanguage"**: string, **"BrowserTimeZone"**: string, **"ScreenResolution"**: string, **"BrowserColorDepth"**: string, **"BrowserJavaEnabled"**: string, **"DeviceExtendedData"**: string, **"BrowserAcceptHeader"**: string, **"BrowserScreenHeight"**: string, **"OperatingSystemName"**: string, **"OperatingSystemVersion"**: string, **"BrowserJavascriptEnabled"**: boolean }, **"FlowStatus"**: string, <br>**Available values:** "Fully Authenticated", "Not Authenticated", "Not Authenticated with Feedback", "Attempts", "Merchant Cancelled", "Cardholder Cancelled", "Incomplete", "Unavailable", "Rejected", "Informational Only", **"PaymentInfo"**: { **"CardType"**: string, <br>**Available values:** "Credit", "Debit", "Not Applicable", **"CardNumber"**: string, **"CardExpiryYear"**: string, **"CardHolderName"**: string, **"CardExpiryMonth"**: string }, **"ReasonCodes"**: { **"Risk"**: { **"ReasonCode"**: string, **"ReasonDescription"**: string }, **"StepUp"**: { **"ReasonCode"**: string, **"ReasonDescription"**: string }, **"Validate"**: { **"ReasonCode"**: string, **"ReasonDescription"**: string }, **"InitiateAction"**: { **"ReasonCode"**: string, **"ReasonDescription"**: string } }, **"AddressMatch"**: string, <br>**Available values:** "Y", "N", **"ConsumerInfo"**: { **"WorkNumber"**: string, **"PhoneNumber"**: string, **"EmailAddress"**: string, **"MobileNumber"**: string }, **"PurchaseType"**: string, <br>**Available values:** "GoodsOrService", "CheckAcceptance", "AccountFunding", "QuasiCash", "PrepaidActivation", **"RuleTriggered"**: string, **"VcasPanStatus"**: string, **"BillingAddress"**: { **"Region"**: string, **"Address1"**: string, **"Address2"**: string, **"Address3"**: string, **"LastName"**: string, **"Locality"**: string, **"FirstName"**: string, **"MiddleName"**: string, **"PostalCode"**: string, **"CountryCode"**: string }, **"MandatedRegion"**: string, <br>**Available values:** "EEA", "NONE", "UNKNOWN", **"ChallengeCancel"**: string, **"ShippingAddress"**: { **"Region"**: string, **"Address1"**: string, **"Address2"**: string, **"Address3"**: string, **"LastName"**: string, **"Locality"**: string, **"FirstName"**: string, **"MiddleName"**: string, **"PostalCode"**: string, **"CountryCode"**: string }, **"TransactionType"**: string, <br>**Available values:** "Purchase", "CardAdd", **"RiskProviderInfo"**: { **"Name"**: string, <br>**Available values:** "ThreatMetrix", **"DeviceId"**: string, **"ProviderId"**: string }, **"TransactionAmount"**: number, **"ConsumerWalletInfo"**: { **"Provider"**: string, **"WalletAge"**: long, **"PaymentCardAge"**: long }, **"TransactionCurrency"**: string, **"TransactionExponent"**: integer, **"TransactionAmountUSD"**: number, **"TransactionTimeStamp"**: string, **"MerchantAdditionalData"**: { **"PreorderDate"**: string, **"GiftCardCount"**: string, **"GiftCardAmount"**: string, **"GiftCardCurrency"**: string, **"DeliveryTimeFrame"**: string, <br>**Available values:** "ElectronicDelivery", "SameDayShipping", "OvernightShipping", "TwoOrMoreDaysShipping", **"ShippingIndicator"**: string, <br>**Available values:** "ShipToBillingAddress", "ShipToVerifiedAddress", "ShipToOtherAddress", "ShipToStore", "DigitalGoods", "TravelOrEventTickets", "Other", **"DeliveryEmailAddress"**: string, **"ReorderItemsIndicator"**: string, <br>**Available values:** "FirstTime", "Reordered", **"PreorderPurchaseIndicator"**: string, <br>**Available values:** "MerchandiseAvailable", "FutureAvailability" } }, **"TransStatusReason"**: string, **"AuthenticationType"**: string, <br>**Available values:** "OTP", "OTPEMAIL", "OTPSMS", "OTPIVR", "KBASINGLE", "BIOMETRIC", "BIOMETRIC_FACIAL", "BIOMETRIC_FINGERPRINT", "OUTOFBANDOTHER", **"AuthenticationResponse"**: string, <br>**Available values:** "Y", "N", "U", "A", "R", "I", **"AdditionalRiskResultInfo"**: { **"IPVelocity"**: string, **"RiskIndicator"**: string, **"DeviceIDVelocity"**: string }, **"MerchantChallengeIndicator"**: string, **"threeDSRequestorPriorAuthenticationInfo"**: { **"threeDSReqPriorRef"**: string, **"threeDSReqPriorAuthData"**: string, **"threeDSReqPriorAuthMethod"**: string, **"threeDSReqPriorAuthTimestamp"**: string } }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | OK. The authentication record was successfully saved. | **application/json**: { **"Error"**: { **"Description"**: string, **"ReferenceNumber"**: string }, **"Status"**: string, <br>**Available values:** "SUCCESS", "FAILURE", "ERROR" }<br> |
| 400 | Bad Request. The request could not be processed due to invalid parameters. | **application/json**: { **"Error"**: { **"Description"**: string, **"ReferenceNumber"**: string }, **"Status"**: string, <br>**Available values:** "SUCCESS", "FAILURE", "ERROR" }<br> |

### [POST] /vca/v1/commercial-step-up/auth/initiate
**Initiate Authentication**

After determining the authentication method using the Get Authentication Method endpoint, the ACS provider invokes this operation to initiate the step-up authentication challenge. Depending on the StepupType specified in the request, the endpoint either sends a One-Time Password (OTP) to the Fintech for the OTP authentication method or notifies the Fintech to initiate a biometric challenge for the BIOMETRIC authentication method.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"IssuerId"**: string, **"StepupType"**: string, <br>**Available values:** "OTP", "BIOMETRIC", **"Credentials"**: [ { **"Id"**: string, **"Text"**: string, **"Type"**: string, <br>**Available values:** "OTPEMAIL", "OTPSMS", "OTPIVR", "KBASINGLE", "BIOMETRIC", "OUTOFBANDOTHER", "OUTOFBANDTOKEN", **"Token"**: string, **"CustomerId"**: string } ], **"PaymentInfo"**: { **"CardType"**: string, <br>**Available values:** "Credit", "Debit", "Not Applicable", **"CardNumber"**: string, **"CardExpiryYear"**: string, **"CardHolderName"**: string, **"CardExpiryMonth"**: string }, **"ProcessorId"**: string, **"3RIIndicator"**: string, **"MerchantInfo"**: { **"AcquirerId"**: string, **"MerchantId"**: string, **"MerchantURL"**: string, **"MerchantName"**: string, **"AcquirerCountryCode"**: string, **"MerchantCountryCode"**: string, **"MerchantCategoryCode"**: string, **"MerchantAppRedirectURL"**: string }, **"CardBrandName"**: string, <br>**Available values:** "DISCOVER", "VISA", "MASTERCARD", "JCB", "AMEX", "DINERS", "ELO", "UPI", "EFTPOS", "MADA", "MYDEBIT", "TAKAPAY", "ITMX", "JAYWAN", **"StepupCounter"**: integer, **"TransactionId"**: string, **"MessageVersion"**: string, **"OOBCallbackUrl"**: string, **"DSTransactionId"**: string, **"MessageCategory"**: string, **"StepupRequestId"**: string, **"TransactionInfo"**: { **"Channel"**: string, <br>**Available values:** "WEB", "APP", "M_WEB", "THREERI", **"MandatedRegion"**: string, <br>**Available values:** "EEA", "NONE", "UNKNOWN", **"TransactionType"**: string, <br>**Available values:** "Purchase", "CardAdd", **"TransactionAmount"**: number, **"TransactionCurrency"**: string, **"TransactionExponent"**: integer, **"TransactionTimeStamp"**: string }, **"OtpReferenceCode"**: string, **"RDXMessageVersion"**: string, **"VerificationToken"**: string, **"ThreeDSRequestorAuthenticationInd"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | OK. The authentication challenge was successfully initiated. | **application/json**: { **"Error"**: { **"Message"**: string, **"Description"**: string, **"ReferenceNumber"**: string, **"ReasonDescription"**: string }, **"Reason"**: { **"ReasonCode"**: string, **"ReasonDescription"**: string }, **"Status"**: string, <br>**Available values:** "SUCCESS", "FAILURE", "ERROR", **"IssuerId"**: string, **"Language"**: string, **"StepupType"**: string, <br>**Available values:** "OTP", "BIOMETRIC", **"Credentials"**: [ { **"Id"**: string, **"Text"**: string, **"Type"**: string, <br>**Available values:** "OTPEMAIL", "OTPSMS", "OTPIVR", "KBASINGLE", "BIOMETRIC", "OUTOFBANDOTHER", "OUTOFBANDTOKEN", **"Token"**: string, **"CustomerId"**: string } ], **"ProcessorId"**: string, **"RiskIndicator"**: string, **"TransactionId"**: string, **"StepupRequestId"**: string, **"TransStatusReason"**: string, **"IsBbConsentRequired"**: boolean }<br> |

### [POST] /vca/v1/commercial-lookup/credential-type
**Get Authentication Method**

This is the initial step in the 3DS step-up authentication flow. An ACS provider calls this endpoint to determine the available authentication methods for a cardholder based on their card and transaction details. The response will specify the Stepup type that should be used for the challenge, such as OTP or BIOMETRIC, enabling the ACS to proceed with the appropriate authentication challenge.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"IssuerId"**: string, **"PaymentInfo"**: { **"CardType"**: string, <br>**Available values:** "Credit", "Debit", "Not Applicable", **"CardNumber"**: string, **"CardExpiryYear"**: string, **"CardHolderName"**: string, **"CardExpiryMonth"**: string }, **"ProcessorId"**: string, **"3RIIndicator"**: string, **"DeviceLocale"**: string, **"MerchantInfo"**: { **"AcquirerId"**: string, **"MerchantId"**: string, **"MerchantURL"**: string, **"MerchantName"**: string, **"AcquirerCountryCode"**: string, **"MerchantCountryCode"**: string, **"MerchantCategoryCode"**: string, **"MerchantAppRedirectURL"**: string }, **"StepupReason"**: string, **"CardBrandName"**: string, <br>**Available values:** "DISCOVER", "VISA", "MASTERCARD", "JCB", "AMEX", "DINERS", "ELO", "UPI", "EFTPOS", "MADA", "MYDEBIT", "TAKAPAY", "ITMX", "JAYWAN", **"ExtensionData"**: { **"DAFExtension"**: { **"Version"**: string, **"DAFAdvice"**: string, **"AuthPayCredStatus"**: string, **"AuthPayProcessReqInd"**: string }, **"VisaPaymentTokenExtension"**: { **"Token"**: string, **"Version"**: string, **"TokenCryptogram"**: string, **"TokenRequestorId"**: string, **"TokenAdditionalData"**: { **"TokenCharacteristics"**: string, <br>**Available values:** "01", "02", "03", "05", "06", **"TokenAdditionalDataVersion"**: string }, **"TokenAssuranceMethod"**: string, **"TokenStatusIndicator"**: string, <br>**Available values:** "A", "I", "S", "D", "P", **"TokenCryptogramValidityIndicator"**: string, <br>**Available values:** "01", "02", "03" } }, **"StepupCounter"**: integer, **"TransactionId"**: string, **"MessageVersion"**: string, **"DSTransactionId"**: string, **"DeviceUserAgent"**: string, **"MessageCategory"**: string, **"StepupRequestId"**: string, **"TransactionInfo"**: { **"Channel"**: string, <br>**Available values:** "WEB", "APP", "M_WEB", "THREERI", **"MandatedRegion"**: string, <br>**Available values:** "EEA", "NONE", "UNKNOWN", **"TransactionType"**: string, <br>**Available values:** "Purchase", "CardAdd", **"TransactionAmount"**: number, **"TransactionCurrency"**: string, **"TransactionExponent"**: integer, **"TransactionTimeStamp"**: string }, **"RDXMessageVersion"**: string, **"EmbeddedOOBResponseUrl"**: string, **"CardholderSelectionInfo"**: { **"Name"**: string, **"Type"**: string, <br>**Available values:** "P", "S" }, **"ThreeDSRequestorAuthenticationInd"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | OK. The available authentication methods were successfully retrieved. | **application/json**: { **"Error"**: { **"Message"**: string, **"Description"**: string, **"ReferenceNumber"**: string, **"ReasonDescription"**: string }, **"Reason"**: { **"ReasonCode"**: string, **"ReasonDescription"**: string }, **"Status"**: string, <br>**Available values:** "SUCCESS", "FAILURE", "ERROR", **"WhyInfo"**: { **"Text"**: string, **"Label"**: string }, **"IssuerId"**: string, **"Language"**: string, **"OobAppURL"**: string, **"StepupType"**: string, <br>**Available values:** "OTP", "BIOMETRIC", **"Credentials"**: [ { **"Id"**: string, **"Text"**: string, **"Type"**: string, <br>**Available values:** "OTPEMAIL", "OTPSMS", "OTPIVR", "KBASINGLE", "BIOMETRIC", "OUTOFBANDOTHER", "OUTOFBANDTOKEN", **"Token"**: string, **"CustomerId"**: string } ], **"ProcessorId"**: string, **"RiskIndicator"**: string, **"TransactionId"**: string, **"StepupRequestId"**: string, **"TransStatusReason"**: string, **"IsBbConsentRequired"**: boolean }<br> |

---
## Rules Management
Users can use Rules Management APIs to manage controls on an existing account in VPC. User should always send all the rules to be set on an account. Once the rules are set, they are active immediately. Rules can be set for future dates. 

### [POST] /vpc/v1/rules/set
**Set Rules**

The Set Rules API allows you to apply controls to existing accounts in VPC, either immediately or at a specified future date. The Visa Developer Platform provides a rule details table that lists all available rules along with their required parameters.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No | **application/json**: { **"rules"**: [ { **"code"**: string, **"policyDetails"**: [ { **"rangeType"**: string, **"dayOfTheWeek"**: string, **"spendLimitAmount"**: string, **"merchantCategoryGroups"**: [ string ], **"merchantCategoryRanges"**: [ { **"maxMCC"**: string, **"minMCC"**: string } ], **"accumulatedSpendResetIndicator"**: string } ], **"velocityDetails"**: { **"maxAuth"**: string, **"rangeType"**: string, **"updateFlag"**: string, **"notifyOption"**: string, **"thresholdAmount"**: string, **"spendLimitAmount"**: string, **"consumedAuthCount"**: integer, **"consumedAuthAmount"**: integer } } ], **"endDate"**: date, **"timezone"**: string, <br>**Default:** GMT Standard Time, **"issuerBid"**: string, **"startDate"**: date, **"ruleCurrency"**: string, **"accountNumber"**: string, **"mcgRuleAction"**: string, <br>**Available values:** "ALLOW", "BLOCK", **"tokenReferenceId"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | OK | **application/json**: { **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 400 | Bad Request | **application/json**: { **"errorCode"**: string, **"requestId"**: string, **"errormessage"**: string }<br> |

### [POST] /vpc/v1/rules/block
**Block Account**

Use this operation to block an existing account from processing any transactions and to remove all rules currently applied to that account.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"issuerBid"**: string, **"accountNumber"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | OK | **application/json**: { **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 400 | Bad Request | **application/json**: { **"errorCode"**: string, **"requestId"**: string, **"errormessage"**: string }<br> |

### [DELETE] /vpc/v1/rules/delete
**Delete Rules**

Use this operation to remove all current and/or future rules from a card. You can clear all rules at once, or use the set rules operation to replace existing rules with new ones. Please note that individual rules cannot be deleted separately.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"issuerBid"**: string, **"accountNumber"**: string, **"deleteFutureRules"**: boolean, **"deleteCurrentRules"**: boolean }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | OK | **application/json**: { **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 400 | Bad Request | **application/json**: { **"errorCode"**: string, **"requestId"**: string, **"errormessage"**: string }<br> |

### [POST] /vpc/v1/rules/disable-enable
**Disable Enable Rules**

Use this operation to temporarily disable all rules on an account. You can also use the same endpoint to re-enable previously disabled rules when needed. Additionally, the disable rule feature allows you to block the account if required.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"blockRule"**: boolean, **"isDisable"**: boolean, **"issuerBid"**: string, **"accountNumber"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | OK | **application/json**: { **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 400 | Bad Request | **application/json**: { **"errorCode"**: string, **"requestId"**: string, **"errormessage"**: string }<br> |

### [POST] /vpc/v1/rules/get
**Get Rules**

Users can use Get Rules API to fetch all the controls set on an account. This API also provides the consumed spending amount and authorization count for the Spend Velocity (SPV) and Spend Policy Control (SPP).

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No | **application/json**: { **"issuerBid"**: string, **"accountNumber"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | OK | **application/json**: { **"rules"**: [ { **"code"**: string, **"policyDetails"**: [ { **"rangeType"**: string, **"dayOfTheWeek"**: string, **"spendLimitAmount"**: string, **"merchantCategoryGroups"**: [ string ], **"merchantCategoryRanges"**: [ { **"maxMCC"**: string, **"minMCC"**: string } ], **"accumulatedSpendResetIndicator"**: string } ], **"velocityDetails"**: { **"maxAuth"**: string, **"rangeType"**: string, **"updateFlag"**: string, **"notifyOption"**: string, **"thresholdAmount"**: string, **"spendLimitAmount"**: string, **"consumedAuthCount"**: integer, **"consumedAuthAmount"**: integer } } ], **"endDate"**: date, **"message"**: string, **"disabled"**: boolean, **"timezone"**: string, <br>**Default:** GMT Standard Time, **"requestId"**: string, **"startDate"**: date, **"futureRules"**: [ { **"code"**: string, **"policyDetails"**: [ { **"rangeType"**: string, **"dayOfTheWeek"**: string, **"spendLimitAmount"**: string, **"merchantCategoryGroups"**: [ string ], **"merchantCategoryRanges"**: [ { **"maxMCC"**: string, **"minMCC"**: string } ], **"accumulatedSpendResetIndicator"**: string } ], **"velocityDetails"**: { **"maxAuth"**: string, **"rangeType"**: string, **"updateFlag"**: string, **"notifyOption"**: string, **"thresholdAmount"**: string, **"spendLimitAmount"**: string, **"consumedAuthCount"**: integer, **"consumedAuthAmount"**: integer } } ], **"messageCode"**: string, **"ruleCurrency"**: string, **"accountNumber"**: string, **"mcgRuleAction"**: string, <br>**Available values:** "ALLOW", "BLOCK", **"disabledwithBlock"**: boolean, **"futureRulesEndDate"**: date, **"futureRulesTimezone"**: string, <br>**Default:** GMT Standard Time, **"futureRulesStartDate"**: date, **"futureRulesRuleCurrency"**: string, **"futureRulesMcgRuleAction"**: string, <br>**Available values:** "ALLOW", "BLOCK" }<br> |
| 400 | Bad Request | **application/json**: { **"errorCode"**: string, **"requestId"**: string, **"errormessage"**: string }<br> |

---
## Supplier Validation
The Supplier Validation solution allows clients to efficiently identify and trust suppliers. Clients may search for and retrieve trusted supplier information, including Acquirer ID and CAID, which can then be used to establish or update payment controls through existing B2B Payment Controls APIs or B2B Payables APIs. This solution supports fraud mitigation in virtual commercial transactions by ensuring that payments are authorized exclusively for verified, trusted suppliers.

### [POST] /suppliervalidation/v1/update
**Update Supplier**

This API permits clients to make changes to the attributes of an already existing Trusted Supplier. Moreover, it includes an option for clients to remove trust at the Supplier or at the Acquirer BIN/CAID level

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| ClientId | header | Client ID field is a unique identification of the financial institution. Provided by Visa during onboarding to VDP | Yes | string | No |
| CorrelationId | header | Correlation ID is a header which we use to trace an api call from VDP to backend | Yes | string | No |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"buyerId"**: string, **"issuerId"**: string, **"messageId"**: string, **"buyerSupplierId"**: string } & { **"supplierTrustStatusInd"**: boolean, **"acquirerBinCaidMappings"**: [ { **"caid"**: string, **"acquirerBin"**: string } & { **"acquirerBinCaidTrustStatusInd"**: boolean } ] }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Successful operation | **application/json**: { **"messageId"**: string, **"statusCode"**: string, **"statusDescription"**: string, **"supplierTrustStatusInd"**: boolean }<br> |
| 400 | Bad request - validation errors | **application/json**: { **"errorCode"**: string, **"messageId"**: string, **"statusCode"**: string, **"errorMessage"**: string, **"statusDescription"**: string }<br> |
| 401 | Authentication error | **application/json**: { **"errorCode"**: string, **"messageId"**: string, **"statusCode"**: string, **"errorMessage"**: string, **"statusDescription"**: string }<br> |
| 500 | Internal server error | **application/json**: { **"errorCode"**: string, **"messageId"**: string, **"statusCode"**: string, **"errorMessage"**: string, **"statusDescription"**: string }<br> |

### [POST] /suppliervalidation/v1/retrieve
**Retrieve Supplier**

This API allows clients to retrieve information regarding Trusted Suppliers

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| ClientId | header | Client ID field is a unique identification of the financial institution. Provided by Visa during onboarding to VDP | Yes | string | No |
| CorrelationId | header | Correlation ID is a header which we use to trace an api call from VDP to backend | Yes | string | No |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"buyerId"**: string, **"issuerId"**: string, **"messageId"**: string, **"buyerSupplierId"**: string } & { **"includeUntrustedBinCaids"**: boolean }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Successful operation | **application/json**: { **"messageId"**: string, **"statusCode"**: string, **"contactInfo"**: { **"city"**: string, **"state"**: string, **"zipCode"**: string, **"countryCode"**: string, **"addressLine1"**: string, **"addressLine2"**: string, **"addressLine3"**: string, **"supplierName"**: string }, **"statusDescription"**: string, **"supplierTrustStatusInd"**: boolean, **"acquirerBinCaidMappings"**: [ { **"caid"**: string, **"acquirerBin"**: string } & { **"acquirerBinCaidTrustStatusInd"**: boolean } ] }<br> |
| 400 | Bad request - validation errors | **application/json**: { **"errorCode"**: string, **"messageId"**: string, **"statusCode"**: string, **"errorMessage"**: string, **"statusDescription"**: string }<br> |
| 401 | Authentication error | **application/json**: { **"errorCode"**: string, **"messageId"**: string, **"statusCode"**: string, **"errorMessage"**: string, **"statusDescription"**: string }<br> |
| 500 | Internal server error | **application/json**: { **"errorCode"**: string, **"messageId"**: string, **"statusCode"**: string, **"errorMessage"**: string, **"statusDescription"**: string }<br> |

### [POST] /api/v1/supplier-validation/register
**Register-Supplier**

Register a new supplier with buyer-supplier relationship details. This operation registers the relationship between a buyer and supplier, including acquirer BIN/CAID information and contact details and returns supplier details upon successful registration.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"caid"**: string, **"buyerId"**: string, **"clientId"**: string, **"issuerBid"**: string, **"requestId"**: string, **"acquirerBin"**: string, **"contactInfo"**: { **"city"**: string, **"state"**: string, **"postalCode"**: string, **"countryCode"**: string, **"addressLine1"**: string, **"addressLine2"**: string, **"addressLine3"**: string, **"supplierName"**: string }, **"buyerSupplierId"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Success | **application/json**: { **"details"**: [ { **"errorCode"**: string, **"errorMessage"**: string } ], **"requestId"**: string, **"statusCode"**: string, **"statusMessage"**: string, **"supplierDetails"**: { **"storeName"**: string, **"supplierCity"**: string or null, **"supplierName"**: string, **"terminalType"**: [ string ] or null, **"supplierState"**: string or null, **"enterpriseName"**: string or null, **"supplierPostalCode"**: string or null, **"supplierCountryCode"**: string or null, **"supplierStreetAddress"**: string or null, **"locationAddressLatitude"**: string or null, **"paymentAcceptanceMethod"**: [ string ] or null, **"locationAddressLongitude"**: string or null }, **"validatedAcquirerBinCaidCount"**: string }<br> |
| 400 | Bad Request — request validation failed | **application/json**: { **"details"**: [ { **"errorCode"**: string, **"errorMessage"**: string } ], **"requestId"**: string, **"statusCode"**: string, **"statusMessage"**: string }<br> |
| 500 | Internal Server Error | **application/json**: { **"requestId"**: string, **"statusCode"**: string, **"statusMessage"**: string }<br> |

### [POST] /api/v1/supplier-validation/retrieve
**Retrieve-Supplier**

Retrieve the validation status for an existing supplier.
Returns the current validation status for the specified acquirer BIN and CAID combination.
If the BIN-CAID is not found locally, the service automatically refreshes from GMR before responding.
If the supplier has been untrusted, returns `isValidated: "false"` without triggering a GMR refresh.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"caid"**: string, **"buyerId"**: string, **"clientId"**: string, **"issuerBid"**: string, **"requestId"**: string, **"acquirerBin"**: string, **"transactionId"**: string, **"buyerSupplierId"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Success | **application/json**: { **"details"**: [ { **"errorCode"**: string, **"errorMessage"**: string } ], **"requestId"**: string, **"statusCode"**: string, **"isValidated"**: string, <br>**Available values:** "true", "false", **"statusMessage"**: string }<br> |
| 400 | Bad Request — request validation failed | **application/json**: { **"details"**: [ { **"errorCode"**: string, **"errorMessage"**: string } ], **"requestId"**: string, **"statusCode"**: string, **"statusMessage"**: string }<br> |
| 500 | Internal Server Error | **application/json**: { **"requestId"**: string, **"statusCode"**: string, **"statusMessage"**: string }<br> |

### [POST] /suppliervalidation/v1/register
**Register Supplier**

This API enables clients to request Visa to create a new Trusted Supplier. Visa will create the supplier and provide all pertinent Acquirer BIN/CAID trust information in the response

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| ClientId | header | Client ID field is a unique identification of the financial institution. Provided by Visa during onboarding | Yes | string | No |
| CorrelationId | header | Correlation ID is a header which we use to trace an api call from VDP to backend | Yes | string | No |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"buyerId"**: string, **"issuerId"**: string, **"messageId"**: string, **"buyerSupplierId"**: string } & { **"caid"**: string, **"acquirerBin"**: string, **"contactInfo"**: { **"city"**: string, **"state"**: string, **"zipCode"**: string, **"countryCode"**: string, **"addressLine1"**: string, **"addressLine2"**: string, **"addressLine3"**: string, **"supplierName"**: string } }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Successful operation | **application/json**: { **"messageId"**: string, **"statusCode"**: string, **"contactInfo"**: { **"city"**: string, **"state"**: string, **"zipCode"**: string, **"countryCode"**: string, **"addressLine1"**: string, **"addressLine2"**: string, **"addressLine3"**: string, **"supplierName"**: string }, **"statusDescription"**: string, **"merchantBinCaidMatchDetail"**: [ { **"caid"**: string, **"acquirerBin"**: string } ], **"acquirerBinCAIDAlreadyTrusted"**: boolean, **"moreMatchesAvailableIndicator"**: boolean }<br> |
| 400 | Bad request - validation errors | **application/json**: { **"errorCode"**: string, **"messageId"**: string, **"statusCode"**: string, **"errorMessage"**: string, **"statusDescription"**: string }<br> |
| 401 | Authentication error | **application/json**: { **"errorCode"**: string, **"messageId"**: string, **"statusCode"**: string, **"errorMessage"**: string, **"statusDescription"**: string }<br> |
| 500 | Internal server error | **application/json**: { **"errorCode"**: string, **"messageId"**: string, **"statusCode"**: string, **"errorMessage"**: string, **"statusDescription"**: string }<br> |

### [PUT] /api/v1/supplier-validation/update
**Update-Supplier**

Update the validation status to untrusted for an existing buyer-supplier relationship.         
Only untrusting is supported — `supplierValidationStatusInd` must be `"false"`.         
Updating at the individual acquirer BIN/CAID level is not supported through this operation.         
Once set to untrusted, the status cannot be reversed via this API.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"buyerId"**: string, **"clientId"**: string, **"issuerBid"**: string, **"requestId"**: string, **"buyerSupplierId"**: string, **"supplierValidationStatusInd"**: string, <br>**Available values:** "false" }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Success | **application/json**: { **"details"**: [ { **"errorCode"**: string, **"errorMessage"**: string } ], **"requestId"**: string, **"statusCode"**: string, **"statusMessage"**: string }<br> |
| 400 | Bad Request — request validation failed | **application/json**: { **"details"**: [ { **"errorCode"**: string, **"errorMessage"**: string } ], **"requestId"**: string, **"statusCode"**: string, **"statusMessage"**: string }<br> |
| 500 | Internal Server Error | **application/json**: { **"requestId"**: string, **"statusCode"**: string, **"statusMessage"**: string }<br> |

---
## Account Management
Users can leverage the Account Management APIs to create and manage their accounts within Visa B2B Payment Controls (VPC). The accounts need to be within the ranges specified during the onboarding of the Issuer or a Commercial Client. This service also allows users to add payment controls, manage account contacts, update company information, delete accounts, and access account details from the system.

### [POST] /vpc/v1/account/get
**Get Account**

Use this operation to retrieve a particular Account's details along with its current contact information.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No | **application/json**: { **"issuerBid"**: string, **"accountNumber"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | OK | **application/json**: { **"data"**: { **"isToken"**: boolean, **"contacts"**: [ { **"contact"**: string, **"countryCode"**: string, **"dialingCode"**: string, **"languageCode"**: string, **"notificationFormat"**: string, **"notificationChannel"**: string, <br>**Available values:** "EMAIL", "SMS", "BOTH", "NONE" } ], **"lastName"**: string, <br>**Default:** LNU, **"firstName"**: string, <br>**Default:** FNU, **"accountKey"**: string, **"companyName"**: string, **"customerClientID"**: string, **"tokenReferenceId"**: string, **"customerCompanyID"**: string }, **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 400 | Bad Request | **application/json**: { **"errorCode"**: string, **"requestId"**: string, **"errorMessage"**: string }<br> |

### [POST] /vpc/v1/account/create
**Create Account**

Use this operation to register your existing cards with VPC, which is required before you can set any rules, other than the Block Rule (this will be available to add while creating the account). You can enroll both a physical or a Visa virtual card. While registering your card, you can specify phone numbers and email addresses to receive SMS and email transaction notifications.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No | **application/json**: { **"isBlock"**: boolean, **"isToken"**: boolean, **"contacts"**: [ { **"contact"**: string, **"countryCode"**: string, **"dialingCode"**: string, **"languageCode"**: string, **"notificationFormat"**: string, **"notificationChannel"**: string, <br>**Available values:** "EMAIL", "SMS", "BOTH", "NONE" } ], **"lastName"**: string, **"firstName"**: string, **"issuerBid"**: string, **"companyName"**: string, **"accountNumber"**: string, **"customerClientId"**: string, **"tokenReferenceId"**: string, **"customerCompanyId"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | OK | **application/json**: { **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 400 | Bad Request | **application/json**: { **"errorCode"**: string, **"requestId"**: string, **"errorMessage"**: string }<br> |

### [DELETE] /vpc/v1/account/delete
**Delete Account**

Use this operation to remove account from VPC when they are no longer needed. Deleting an account will also remove all associated rules and notifications from VPC.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"issuerBid"**: string, **"accountNumber"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | OK | **application/json**: { **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 400 | Bad Request | **application/json**: { **"errorCode"**: string, **"requestId"**: string, **"errorMessage"**: string }<br> |

### [PUT] /vpc/v1/account/update
**Update Account**

Use this operation to update your existing cards registered with VPC. You can modify any of the details that were provided during the initial account setup.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No | **application/json**: { **"isToken"**: boolean, **"contacts"**: [ { **"action"**: string, <br>**Available values:** "A", "D", **"contact"**: string, **"countryCode"**: string, **"dialingCode"**: string, **"languageCode"**: string, **"notificationFormat"**: string, **"notificationChannel"**: string, <br>**Available values:** "EMAIL", "SMS", "BOTH", "NONE" } ], **"lastName"**: string, <br>**Default:** LNU, **"firstName"**: string, <br>**Default:** FNU, **"issuerBid"**: string, **"accountNumber"**: string, **"tokenReferenceId"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | OK | **application/json**: { **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 400 | Bad Request | **application/json**: { **"errorCode"**: string, **"requestId"**: string, **"errorMessage"**: string }<br> |

---
## Account Administration - Deprecated
Users can use the Account Administration APIs to add their accounts in VPC and manage them. It allows an entity to create an account, update account details, delete an account, and retrieve account summary and details.<br><br><b>Response code and description</b>: Refer to <a href=/capabilities/visa-b2b-payment-controls/docs-error-codes>Response code and description.</a>

### [POST] /vpc/v1/accountAdministration/get
**Get Account Details**

Users can use Get Account API to fetch all the details about an account, number of controls and contacts enabled on an account.

#### Request Body

Users can use Get Account API to fetch all the details about an account, number of controls and contacts enabled on an account.

| Required | Schema |
| -------- | ------ |
|  No | **application/json-patch+json**: { **"accounts"**: [ { **"serviceKey"**: string, **"accountNumber"**: string, **"sequenceNumber"**: string } ], **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string }<br>**application/json**: { **"accounts"**: [ { **"serviceKey"**: string, **"accountNumber"**: string, **"sequenceNumber"**: string } ], **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string }<br>**text/json**: { **"accounts"**: [ { **"serviceKey"**: string, **"accountNumber"**: string, **"sequenceNumber"**: string } ], **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string }<br>**application/*+json**: { **"accounts"**: [ { **"serviceKey"**: string, **"accountNumber"**: string, **"sequenceNumber"**: string } ], **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Success Response | **application/json**: { **"data"**: { **"companyId"**: string, **"accountStatus"**: [ { **"status"**: string, **"serviceKey"**: string, **"statusMessage"**: string, **"accountDetails"**: { **"expYear"**: string, **"isToken"**: boolean, **"expMonth"**: string, **"isBlocked"**: boolean, **"ruleCount"**: string, **"accountLast4"**: string, **"emailContactCount"**: string, **"cardholderLastName"**: string, **"isControlSuspended"**: boolean, **"mobileContactCount"**: string, **"cardholderFirstName"**: string }, **"sequenceNumber"**: string, **"statusMessageCode"**: string } ] }, **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 207 | Mutli-status responses. This response is seen in case of bulk request scenario. For this response, go through each response to get the status of each account. | **application/json**: { **"data"**: { **"companyId"**: string, **"accountStatus"**: [ { **"status"**: string, **"serviceKey"**: string, **"statusMessage"**: string, **"accountDetails"**: { **"expYear"**: string, **"isToken"**: boolean, **"expMonth"**: string, **"isBlocked"**: boolean, **"ruleCount"**: string, **"accountLast4"**: string, **"emailContactCount"**: string, **"cardholderLastName"**: string, **"isControlSuspended"**: boolean, **"mobileContactCount"**: string, **"cardholderFirstName"**: string }, **"sequenceNumber"**: string, **"statusMessageCode"**: string } ] }, **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 400 | Error Response | **application/json**: { **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |

### [PUT] /vpc/v1/accountAdministration/update
**Update Account**

Users can use the Update Account API to update the account data which includes the first name, last name and expiration date. This API also allows user to update the block status and enable/disable controls on an account.

#### Request Body

Users can use the Update Account API to update the account data which includes the first name, last name and expiration date. This API also allows user to update the block status and enable/disable controls on an account.

| Required | Schema |
| -------- | ------ |
|  No | **application/json-patch+json**: { **"expYear"**: string, **"clientId"**: string, **"expMonth"**: string, **"companyId"**: string, **"isBlocked"**: boolean, **"issuerBid"**: string, **"requestID"**: string, **"serviceKey"**: string, **"accountNumber"**: string, **"cardholderLastName"**: string, **"isControlSuspended"**: boolean, **"cardholderFirstName"**: string }<br>**application/json**: { **"expYear"**: string, **"clientId"**: string, **"expMonth"**: string, **"companyId"**: string, **"isBlocked"**: boolean, **"issuerBid"**: string, **"requestID"**: string, **"serviceKey"**: string, **"accountNumber"**: string, **"cardholderLastName"**: string, **"isControlSuspended"**: boolean, **"cardholderFirstName"**: string }<br>**text/json**: { **"expYear"**: string, **"clientId"**: string, **"expMonth"**: string, **"companyId"**: string, **"isBlocked"**: boolean, **"issuerBid"**: string, **"requestID"**: string, **"serviceKey"**: string, **"accountNumber"**: string, **"cardholderLastName"**: string, **"isControlSuspended"**: boolean, **"cardholderFirstName"**: string }<br>**application/*+json**: { **"expYear"**: string, **"clientId"**: string, **"expMonth"**: string, **"companyId"**: string, **"isBlocked"**: boolean, **"issuerBid"**: string, **"requestID"**: string, **"serviceKey"**: string, **"accountNumber"**: string, **"cardholderLastName"**: string, **"isControlSuspended"**: boolean, **"cardholderFirstName"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Success Response | **application/json**: { **"data"**: { **"accountStatus"**: { **"serviceKey"**: string, **"accountLast4"**: string } }, **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 400 | Error Response | **application/json**: { **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |

### [POST] /vpc/v1/accountAdministration/create
**Create Account**

The Create Account API allows the user to add an account to a company within VPC. After an account is added, user can then add controls and contacts to leverage full API capabilities. Accounts can be added individually or can be added in bulk through this API. User will receive back the service key per account to use in subsequent calls. User can also add an account with blocked status to restrict the account usage. <br><br><b>Note</b>: Bulk capability is limited to 250 accounts per call.

#### Request Body

The Create Account API allows the user to add an account to a company within VPC. After an account is added, user can then add controls and contacts to leverage full API capabilities. Accounts can be added individually or can be added in bulk through this API. User will receive back the service key per account to use in subsequent calls. User can also add an account with blocked status to restrict the account usage. <br><br><b>Note</b>: Bulk capability is limited to 250 accounts per call.

| Required | Schema |
| -------- | ------ |
|  No | **application/json-patch+json**: { **"accounts"**: [ { **"cvv"**: string, **"expYear"**: string, **"isToken"**: boolean, **"expMonth"**: string, **"isBlocked"**: boolean, **"accountNumber"**: string, **"sequenceNumber"**: string, **"cardholderLastName"**: string, **"cardholderFirstName"**: string } ], **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string }<br>**application/json**: { **"accounts"**: [ { **"cvv"**: string, **"expYear"**: string, **"isToken"**: boolean, **"expMonth"**: string, **"isBlocked"**: boolean, **"accountNumber"**: string, **"sequenceNumber"**: string, **"cardholderLastName"**: string, **"cardholderFirstName"**: string } ], **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string }<br>**text/json**: { **"accounts"**: [ { **"cvv"**: string, **"expYear"**: string, **"isToken"**: boolean, **"expMonth"**: string, **"isBlocked"**: boolean, **"accountNumber"**: string, **"sequenceNumber"**: string, **"cardholderLastName"**: string, **"cardholderFirstName"**: string } ], **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string }<br>**application/*+json**: { **"accounts"**: [ { **"cvv"**: string, **"expYear"**: string, **"isToken"**: boolean, **"expMonth"**: string, **"isBlocked"**: boolean, **"accountNumber"**: string, **"sequenceNumber"**: string, **"cardholderLastName"**: string, **"cardholderFirstName"**: string } ], **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Success Response | **application/json**: { **"data"**: { **"accountsStatus"**: [ { **"status"**: string, **"serviceKey"**: string, **"accountLast4"**: string, **"statusMessage"**: string, **"sequenceNumber"**: string, **"statusMessageCode"**: string } ] }, **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 207 | Mutli-status responses. This response is seen in case of bulk request scenario. For this response, go through each response to get the status of each account. | **application/json**: { **"data"**: { **"accountsStatus"**: [ { **"status"**: string, **"serviceKey"**: string, **"accountLast4"**: string, **"statusMessage"**: string, **"sequenceNumber"**: string, **"statusMessageCode"**: string } ] }, **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 400 | Error Response | **application/json**: { **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |

### [DELETE] /vpc/v1/accountAdministration/delete
**Delete Account**

Users can use Delete Account API to remove the account from Visa Payment Controls. This will also remove all the existing controls on an account making it open for all transactions.

#### Request Body

Users can use Delete Account API to remove the account from Visa Payment Controls. This will also remove all the existing controls on an account making it open for all transactions.

| Required | Schema |
| -------- | ------ |
|  No | **application/json-patch+json**: { **"accounts"**: [ { **"serviceKey"**: string, **"accountNumber"**: string, **"sequenceNumber"**: string } ], **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string }<br>**application/json**: { **"accounts"**: [ { **"serviceKey"**: string, **"accountNumber"**: string, **"sequenceNumber"**: string } ], **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string }<br>**text/json**: { **"accounts"**: [ { **"serviceKey"**: string, **"accountNumber"**: string, **"sequenceNumber"**: string } ], **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string }<br>**application/*+json**: { **"accounts"**: [ { **"serviceKey"**: string, **"accountNumber"**: string, **"sequenceNumber"**: string } ], **"clientId"**: string, **"companyId"**: string, **"issuerBid"**: string, **"requestID"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Success Response | **application/json**: { **"data"**: { **"accountsStatus"**: [ { **"status"**: string, **"serviceKey"**: string, **"accountLast4"**: string, **"statusMessage"**: string, **"sequenceNumber"**: string, **"statusMessageCode"**: string } ] }, **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 207 | Mutli-status responses. This response is seen in case of bulk request scenario. For this response, go through each response to get the status of each account. | **application/json**: { **"data"**: { **"accountsStatus"**: [ { **"status"**: string, **"serviceKey"**: string, **"accountLast4"**: string, **"statusMessage"**: string, **"sequenceNumber"**: string, **"statusMessageCode"**: string } ] }, **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 400 | Error Response | **application/json**: { **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |

---
## Intelligent Payment Controls
These APIs enables users to generate, validate, and set business rules using a conversational AI service integrated with various backend modules. The flow supports iterative modification and validation, ensuring that the rules meet business requirements before being finalized and se

### [POST] /vpc/v1/vpcgenai/get
**Get Rule Suggestions**

The users can generate card control rules based on a user's use case provided in plain (natural language) text.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No | **application/json**: { **"prompt"**: string, **"contextId"**: string, **"issuerBid"**: string, **"vpcClientId"**: string, **"accountNumber"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | OK | **application/json**: { **"message"**: string, **"requestId"**: string, **"ruleSetId"**: string, **"actionRequired"**: string, **"setRulesRequest"**: { **"rules"**: [ { **"code"**: string, **"policyDetails"**: [ { **"rangeType"**: string, **"dayOfTheWeek"**: string, **"spendLimitAmount"**: string, **"merchantCategoryGroups"**: [ string ], **"merchantCategoryRanges"**: [ { **"maxMCC"**: string, **"minMCC"**: string } ], **"accumulatedSpendResetIndicator"**: string } ], **"velocityDetails"**: { **"maxAuth"**: string, **"rangeType"**: string, **"updateFlag"**: string, **"notifyOption"**: string, **"thresholdAmount"**: string, **"spendLimitAmount"**: string, **"consumedAuthCount"**: integer, **"consumedAuthAmount"**: integer } } ], **"endDate"**: string, **"timezone"**: string, <br>**Default:** GMT Standard Time, **"startDate"**: string, **"ruleCurrency"**: string, **"mcgRuleAction"**: string, <br>**Available values:** "ALLOW", "BLOCK" }, **"validationErrors"**: { **"errorCode"**: string, **"errorMessage"**: string } }<br> |
| 400 | Bad Request | **application/json**: { **"errorCode"**: string, **"requestId"**: string, **"errorMessage"**: string }<br> |

### [POST] /vpc/v1/vpcgenai/setSuggestedRules
**Set Suggested Modified Rules**

The Set Suggested Rules is used to set the controls generated by AI and use ruleSetId generated in Get Rule Suggestions API

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"modified"**: boolean, **"contextId"**: string, **"issuerBid"**: string, **"ruleSetId"**: string, **"vpcClientId"**: string, **"accountNumber"**: string, **"setModifiedRules"**: { **"rules"**: [ { **"code"**: string, **"policyDetails"**: [ { **"rangeType"**: string, **"dayOfTheWeek"**: string, **"spendLimitAmount"**: string, **"merchantCategoryGroups"**: [ string ], **"merchantCategoryRanges"**: [ { **"maxMCC"**: string, **"minMCC"**: string } ], **"accumulatedSpendResetIndicator"**: string } ], **"velocityDetails"**: { **"maxAuth"**: string, **"rangeType"**: string, **"updateFlag"**: string, **"notifyOption"**: string, **"thresholdAmount"**: string, **"spendLimitAmount"**: string, **"consumedAuthCount"**: integer, **"consumedAuthAmount"**: integer } } ], **"endDate"**: string, **"timezone"**: string, <br>**Default:** GMT Standard Time, **"startDate"**: string, **"ruleCurrency"**: string, **"accountNumber"**: string, **"mcgRuleAction"**: string, <br>**Available values:** "ALLOW", "BLOCK", **"tokenReferenceId"**: string } }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | OK | **application/json**: { **"modifiedRulesSuccessResponse"**: { **"message"**: string, **"requestId"**: string, **"messageCode"**: string } }<br> |
| 400 | Bad Request | **application/json**: { **"errorCode"**: string, **"requestId"**: string, **"errorMessage"**: string }<br> |

---
## Report Management
The Report Management APIs allows user to retrieve both declined transactions and approved transactions (for Spend Velocity and Exact Match rules only) details and also shows the notifications sent out for each transaction. 

### [POST] /vpc/v1/report/get-transaction-history
**Get Transaction History**

The Get Transaction History API allows users to retrieve all the decline and approved (SPV and Exact match only) transaction history based on the specified date range up to last 27 months. 
 
Pagination is supported by this API using the "isLastDataSet" field in the response. When the field "isLastDataSet" value is "False" in the response, the field "pageNumber" can be updated to get the subsequent data set.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"endDate"**: string, **"issuerBid"**: string, **"startDate"**: string, **"pageNumber"**: integer, <br>**Default:** 1, **"accountNumber"**: string, **"maxRecordsToReturn"**: integer, <br>**Default:** 250 }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Successful Response | **application/json**: { **"data"**: { **"transactions"**: [ { **"mccCode"**: string, **"actionText"**: string, **"billerAmount"**: string, **"currencyCode"**: string, **"merchantName"**: string, **"transactionId"**: string, **"billerCurrency"**: string, **"cardAcceptorId"**: string, **"triggerTypeCode"**: [ string ], **"triggerTypeText"**: [ string ], **"merchantLocation"**: string, **"transactionAmount"**: string, **"transactionTimeStamp"**: string } ], **"isLastDataSet"**: boolean }, **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 400 | Bad Request | **application/json**: { **"errorCode"**: string, **"requestId"**: string, **"errorMessage"**: string }<br> |

### [POST] /vpc/v1/report/get-notification-history
**Get Notification History**

The Get Notification History API allows users to retrieve notification history and message details based on the specified date range for all declined transactions and specific approved transaction for Spend Velocity and Exact match rules up to last 27 months. 
 
Pagination is supported by this API using the "isLastDataSet" field in the response. When the field "isLastDataSet" value is "False" in the response, the field "pageNumber" can be updated to get the subsequent data set. 
 
**Note**: Notifications must be enabled to get the notification history.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"endDate"**: string, **"issuerBid"**: string, **"startDate"**: string, **"pageNumber"**: integer, <br>**Default:** 1, **"accountNumber"**: string, **"maxRecordsToReturn"**: integer, <br>**Default:** 250 }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Successful Response | **application/json**: { **"data"**: { **"isLastDataSet"**: boolean, **"notifications"**: [ { **"messages"**: [ { **"contactType"**: string, **"messageText"**: string } ], **"transaction"**: [ { **"mccCode"**: string, **"actionText"**: string, **"billerAmount"**: string, **"currencyCode"**: string, **"merchantName"**: string, **"transactionId"**: string, **"billerCurrency"**: string, **"cardAcceptorId"**: string, **"triggerTypeCode"**: [ string ], **"triggerTypeText"**: [ string ], **"merchantLocation"**: string, **"transactionAmount"**: string, **"transactionTimeStamp"**: string } ], **"contactStatus"**: [ { **"isHTML"**: boolean, **"contact"**: string, **"contactType"**: string, **"countryCode"**: string, **"languageCode"**: string } ] } ] }, **"message"**: string, **"requestId"**: string, **"messageCode"**: string }<br> |
| 400 | Bad Request | **application/json**: { **"errorCode"**: string, **"requestId"**: string, **"errorMessage"**: string }<br> |

---
## Commercial Directory
The Commercial Directory Service enables financial institutions to manage user-to-account mappings for commercial card programs using an asynchronous model. When a client submits a request, the service returns a 202 Accepted status with a unique requestId for tracking. The request is then processed in the background, with results delivered via a callback URL or retrieved by polling a status endpoint with the requestId. For efficiency, the API supports batch operations of up to 250 records. Storing the requestId is critical for tracking the outcome. Upon successful creation, each mapping is assigned a unique userMappingId. This userMappingId is essential for all subsequent lifecycle operations—such as updates, deletions, and queries—and is also the key used to initiate authentication for that specific mapping.

### [POST] /vca/v1/user-mappings/bulk-query
**Get User Mapping**

Submit a request to retrieve multiple user mappings by their IDs. Service validates request, returns immediate acknowledgement, and retrieves mappings asynchronously. Maximum 250 IDs per request. Returns full mapping details with masked account numbers. Following the API's asynchronous pattern, the results of the get operation will be delivered to your callback URL or can be retrieved by polling the status endpoint using a request Id.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"clientId"**: string, **"issuerBid"**: string, **"userMappingIds"**: [ string (uuid) ], **"callbackRequired"**: boolean }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 202 | Accepted | **application/json**: { **"status"**: string, <br>**Available values:** "ACCEPTED", **"requestId"**: string (uuid) }<br> |
| 400 | Bad Request - Validation errors or database validation failures | **application/json**: { **"error"**: { **"code"**: string, **"details"**: [ { **"errorCode"**: string, **"errorMessage"**: string } ], **"message"**: string, **"requestId"**: string (uuid) } }<br> |
| 500 | Internal Server Error | **application/json**: { **"error"**: { **"code"**: string, **"details"**: [ { **"errorCode"**: string, **"errorMessage"**: string } ], **"message"**: string, **"requestId"**: string (uuid) } }<br> |

#### Callback: processingComplete

##### [POST] `{$pre-configured-fintech-callback-url}`
**Query results notification**

Callback with full details of retrieved user mappings

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"requestId"**: string (uuid), **"userMappingResults"**: [ { **"status"**: string, <br>**Available values:** "success", **"userId"**: string, **"account"**: string, **"endDate"**: dateTime, **"clientId"**: string, **"timezone"**: string, **"companyId"**: string, **"issuerBid"**: string, **"statusCode"**: string, **"accountType"**: string, <br>**Available values:** "PLASTIC", "VIRTUAL", "TOKEN", "FUNDING", "PAN", **"accountPoolId"**: string, **"statusMessage"**: string, **"userMappingId"**: string (uuid), **"authenticationMethod"**: string, <br>**Available values:** "OTP", "BIOMETRIC" } or { **"status"**: string, <br>**Available values:** "error", **"statusCode"**: string, **"errorDetails"**: [ { **"errorCode"**: string, **"errorMessage"**: string } ], **"statusMessage"**: string, **"userMappingId"**: string (uuid) } ] }<br> |

#### Responses

| Code | Description |
| ---- | ----------- |
| 200 | OK |

### [POST] /vca/v1/user-mappings/bulk-delete
**Delete User Mapping**

Submit a request to delete multiple user mappings. The operation performs a logical "soft delete," marking the specified mappings as inactive rather than permanently removing them from the system. You can include a maximum of 250 userMappingIds in a single request. Please note that only active mappings are eligible for deletion, and once a mapping is deleted, it cannot be reactivated. Following the API's asynchronous pattern, the results of the delete operation will be delivered to your callback URL or can be retrieved by polling the status endpoint using a request Id. Deleting a mapping will cause all subsequent authentication attempts for the associated account to fail until a new, active mapping is created for it.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"clientId"**: string, **"issuerBid"**: string, **"userMappingIds"**: [ string (uuid) ], **"callbackRequired"**: boolean }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 202 | Accepted | **application/json**: { **"status"**: string, <br>**Available values:** "ACCEPTED", **"requestId"**: string (uuid) }<br> |
| 400 | Bad Request - Validation errors or database validation failures | **application/json**: { **"error"**: { **"code"**: string, **"details"**: [ { **"errorCode"**: string, **"errorMessage"**: string } ], **"message"**: string, **"requestId"**: string (uuid) } }<br> |
| 500 | Internal Server Error | **application/json**: { **"error"**: { **"code"**: string, **"details"**: [ { **"errorCode"**: string, **"errorMessage"**: string } ], **"message"**: string, **"requestId"**: string (uuid) } }<br> |

#### Callback: processingComplete

##### [POST] `{$pre-configured-fintech-callback-url}`
**Delete results notification**

Callback with results of delete operations

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"requestId"**: string (uuid), **"userMappingResults"**: [ { **"status"**: string, <br>**Available values:** "success", **"statusCode"**: string, **"statusMessage"**: string, **"userMappingId"**: string (uuid) } or { **"status"**: string, <br>**Available values:** "error", **"statusCode"**: string, **"errorDetails"**: [ { **"errorCode"**: string, **"errorMessage"**: string } ], **"statusMessage"**: string, **"userMappingId"**: string (uuid) } ] }<br> |

#### Responses

| Code | Description |
| ---- | ----------- |
| 200 | OK |

### [POST] /vca/v1/user-mappings/status
**Get Request Status**

Poll for status and detailed results of a previously submitted request using the requestId from acknowledgement response. Returns 200 OK with results when processing is complete. Response schema varies by original request type. Results include success or failure status for each record in the batch.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"clientId"**: string, **"issuerBid"**: string, **"requestId"**: string (uuid) }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | OK | **application/json**: { **"requestId"**: string (uuid), **"userMappingResults"**: [ { **"status"**: string, <br>**Available values:** "success", **"sequence"**: string, **"statusMessage"**: string, **"userMappingId"**: string (uuid) } or { **"status"**: string, <br>**Available values:** "error", **"sequence"**: string, **"statusCode"**: string, **"errorDetails"**: [ { **"errorCode"**: string, **"errorMessage"**: string } ], **"statusMessage"**: string } ] } or { **"requestId"**: string (uuid), **"userMappingResults"**: [ { **"status"**: string, <br>**Available values:** "success", **"userId"**: string, **"account"**: string, **"endDate"**: dateTime, **"clientId"**: string, **"timezone"**: string, **"companyId"**: string, **"issuerBid"**: string, **"statusCode"**: string, **"accountType"**: string, <br>**Available values:** "PLASTIC", "VIRTUAL", "TOKEN", "FUNDING", "PAN", **"accountPoolId"**: string, **"statusMessage"**: string, **"userMappingId"**: string (uuid), **"authenticationMethod"**: string, <br>**Available values:** "OTP", "BIOMETRIC" } or { **"status"**: string, <br>**Available values:** "error", **"statusCode"**: string, **"errorDetails"**: [ { **"errorCode"**: string, **"errorMessage"**: string } ], **"statusMessage"**: string, **"userMappingId"**: string (uuid) } ] } or { **"requestId"**: string (uuid), **"userMappingResults"**: [ { **"status"**: string, <br>**Available values:** "success", **"statusCode"**: string, **"statusMessage"**: string, **"userMappingId"**: string (uuid) } or { **"status"**: string, <br>**Available values:** "error", **"statusCode"**: string, **"errorDetails"**: [ { **"errorCode"**: string, **"errorMessage"**: string } ], **"statusMessage"**: string, **"userMappingId"**: string (uuid) } ] } or { **"requestId"**: string (uuid), **"userMappingResults"**: [ { **"status"**: string, <br>**Available values:** "success", **"statusCode"**: string, **"statusMessage"**: string, **"userMappingId"**: string (uuid) } or { **"status"**: string, <br>**Available values:** "error", **"statusCode"**: string, **"errorDetails"**: [ { **"errorCode"**: string, **"errorMessage"**: string } ], **"statusMessage"**: string, **"userMappingId"**: string (uuid) } ] }<br> |
| 400 | Bad Request - Validation errors or database validation failures | **application/json**: { **"error"**: { **"code"**: string, **"details"**: [ { **"errorCode"**: string, **"errorMessage"**: string } ], **"message"**: string, **"requestId"**: string (uuid) } }<br> |
| 500 | Internal Server Error | **application/json**: { **"error"**: { **"code"**: string, **"details"**: [ { **"errorCode"**: string, **"errorMessage"**: string } ], **"message"**: string, **"requestId"**: string (uuid) } }<br> |

### [POST] /vca/v1/user-mappings/bulk-create
**Create User Mapping**

Submit a request to create multiple user-to-account mappings. Service validates request, returns immediate acknowledgement with requestId, and processes mappings asynchronously. Maximum 250 mappings per request. Each account can only be mapped to one user at a time. Following the API's asynchronous pattern, the results of the create operation will be delivered to your callback URL or can be retrieved by polling the status endpoint using a request Id.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"clientId"**: string, **"issuerBid"**: string, **"userMappings"**: [ { **"userId"**: string, **"account"**: string, **"endDate"**: date, **"sequence"**: string, **"timezone"**: string, **"companyId"**: string, **"accountType"**: string, <br>**Available values:** "PLASTIC", "VIRTUAL", "TOKEN", "FUNDING", "PAN", **"accountPoolId"**: string, **"authenticationMethod"**: string, <br>**Available values:** "OTP", "BIOMETRIC" } ], **"callbackRequired"**: boolean }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 202 | Accepted | **application/json**: { **"status"**: string, <br>**Available values:** "ACCEPTED", **"requestId"**: string (uuid) }<br> |
| 400 | Bad Request | **application/json**: { **"error"**: { **"code"**: string, **"details"**: [ { **"errorCode"**: string, **"errorMessage"**: string } ], **"message"**: string, **"requestId"**: string (uuid) } }<br> |
| 500 | Internal Server Error | **application/json**: { **"error"**: { **"code"**: string, **"details"**: [ { **"errorCode"**: string, **"errorMessage"**: string } ], **"message"**: string, **"requestId"**: string (uuid) } }<br> |

#### Callback: processingComplete

##### [POST] `{$pre-configured-fintech-callback-url}`
**Processing completion notification**

Callback sent to the client-provided URL when request processing is complete. 
Contains detailed results for each user mapping in the batch.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"requestId"**: string (uuid), **"userMappingResults"**: [ { **"status"**: string, <br>**Available values:** "success", **"sequence"**: string, **"statusMessage"**: string, **"userMappingId"**: string (uuid) } or { **"status"**: string, <br>**Available values:** "error", **"sequence"**: string, **"statusCode"**: string, **"errorDetails"**: [ { **"errorCode"**: string, **"errorMessage"**: string } ], **"statusMessage"**: string } ] }<br> |

#### Responses

| Code | Description |
| ---- | ----------- |
| 200 | OK |

### [PUT] /vca/v1/user-mappings/bulk-update
**Update User Mapping**

[...]
